// BigDemoDlg.cpp : implementation file
//

#include "stdafx.h"
#include "BigDemo.h"
#include "BigDDlg.h"

//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Flex6 utilities
//
// Implemented in FlexUtil.cpp. Utilities provided include:
//
// - pixel/twip conversions
// - symbolic constants for all enumerations
// - CvsFlexGridDataObject class for OLE drag drop
//
#include "FlexUtil.h"       


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// MFC's CPictureHolder support
//
// This is implemented in CtlPict.cpp, which is a part of the MFC dll 
// implementation but is *not* included in the MFC static library.
//
// To build this project using the MFC static library version, you
// will have to include the CtlPict.cpp file in the project.
//
#include <afxctl.h>         


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// List of available demos (used for populating the menu control)
//
// The first string (name) appears on the menu. If it contains a colon (:),
// then it is treated as a collapsible group heading (or tree branch or 
// whatever you prefer to call it). 
//
// The second string (help) is displayed on the dialog caption
//
// The demoId is a unique identifier used to keep track of which demo
// to execute, and which one is active.
//
// New demos may be inserted in any physical position on the menu, and
// existing items may be moved around, but demoIds must be unique and should 
// not be changed once they have been created. 
// 
typedef struct tagDEMOMENU
{
	LPSTR name;
	LPSTR help;
	short demoId;
} DEMOMENU;

DEMOMENU menuOptions[] =
{
    "Editing:",                      "",										0, //
        "Masks",                     "Type into a cell to see masked input",	1, //*
        "Popups",                    "Click on cell buttons to pop up dialogs",	2, //*
        "Combos",                    "Drop down multi-column combos",			3, //*
    "Formatting:",                   "",										4, //
        "Numbers, Dates, Bools",     "See how entries are formatted",			5, //*
        "Cell Property",             "Use the cell property for formatting",	6, //*
//  "Array Binding:",                "",										7,
//      "2D-VB Arrays",              "TODO",									8,
//      "3D-VB Arrays",              "TODO",									9,
//      "2D-ADO Arrays",             "TODO",									10,
//      "Synchronized controls",     "TODO",									11,
//      "Bind to another FlexArray", "TODO",									12,
    "Goodies:",                      "TODO",									13, //*
        "AutoSearch",                "Start typing and watch the selection",	14, //*
        "Explorer Bar",              "Click headings to sort, drag to reorder",	15, //*
        "ScrollTips",				"Scroll up and down with the scrollbar",	16, //*
        "OwnerDraw",				"Select colors to mix",						17, //*
    "Outlines/Totals:",              "",										18, //
        "Sales Report",              "Report with merging and subtotals",		19, //*
        "Custom Tree",               "Create custom outlines",					20, //*
    "Drag Drop:",					"",											21, //
        "Automatic OleDD",           "Drag selection by its edges",				22, //*
        "Manual OleDD",              "Drop files to see their contents",		23, //*
    NULL,                            NULL,										24, //
};


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Dummy variant used in place of omitted optional parameters
// 
COleVariant vDef(0L, VT_ERROR);


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// Dummy data used to populate the grids
// 
LPSTR slFirstNames =  "Abraham|Benjamin|Charles|Don|Edward|Fred|Gerald|Hillary|"
                      "Irah|John|Kelly|Lee|Marcie|Norman|Oscar|Paula|Quincy|Rod|"
                      "Steve|Thomas|Uma|Victor|Wanda|Xavier|Yasmin|Zoe";
LPSTR slLastNames  =  "Ackermann|Bonham|Cunningham|Donahue|Eastman|Foster|Grossman|Healey|"
                      "Idelman|Jordan|Keller|Leary|Moore|Neary|O'Hara|Petty";
LPSTR slPhones     =  "(555) 123-4543|(555) 526-8703|(555) 567-3123|(555) 234-0897|"
                      "(555) 654-4656|(555) 342-4347|(555) 867-3003|(555) 456-3443";
LPSTR slCards      =  "1111 2222 3333 4444|2222 3333 4444 5555|3333 4444 5555 6666|"
                      "4444 5555 6666 7777|5555 6666 7777 8888";
LPSTR slDates      =  "3/4/98|2/5/97|6/8/97|2/4/96|2/6/98|9/2/96|1/5/94|1/4/96";
LPSTR slFileSizes  =  "12331|2344234|234434|4564|423421|5674634|65644|534533|131231|12311|"
                      "34534|3452352|1232|123454|756744|53452|345245|235243|23455|342134";
LPSTR slFileNames  =  "jautoexp.dat|twain_32.dll|explorer.exe|msimgsiz.dat|winsock.dll|"
                      "expostrt.exe|plcdsr21.dat|script.doc|extrac32.exe|powpan.dat|"
                      "protman.dos|faxcover.exe|saifif.dat|dirdib.drv|faxview.exe|"
                      "sb16pnp1.dat|filexfer.exe|sb16pnpd.dat|arp.exe|fontview.exe";
LPSTR slProduct    =  "Applets|Widgets|Doohikeys|Doodads|Foobars|Thingamabobs";
LPSTR slComboNames =  "#111*1;Nuno\tMindelis\tBroadway, 1232\t972-2321|"
                      "#222;Richie\tBlackmore\tSpruce, 500-T\t342-2321|"
                      "#333;Steve\tHowe\tLombard, 543\t011 55 023/955-4561|"
                      "#444;Trevor\tRabin\tMain, 1232\t972-2321|"
                      "#555;Martin\tBarre\tMarine, 1137\t345-2342|"
                      "#666;Joe\tSatriani\tLos Angeles, 500-T\t342-2321|"
                      "#777;Eddie\tVan Halen\tMadera, 543\t011 55 023/955-4561|"
                      "#888;Brian\tMay\tBullock, 500-T\t342-2321|"
                      "#999;Frank\tSolari\tGeary, 543\t011 55 023/955-4561";
LPSTR slComboPhones = "#1*1;Main Office\t(415) 555-1212|"
                      "#2;East Coast Office\t(212) 444-1212|"
                      "#3;Main FAX\t(415) 333-1212|"
                      "#4;Order Desk\t(800) 222-1212|"
                      "#5;Help Desk\t(800) 111-1212";

// translated combo list: the data value is an RGB that corresponds to the color
//
LPSTR slColors      = "#00000000;Black|"
					  "#16777215;White|"
					  "#00000255;Red|"
					  "#00049152;Green|"
					  "#16711680;Blue|"
					  "#00065535;Yellow|"
					  "#12583104;Purple|"
					  "#16776960;Acqua";
LPSTR slRGBColors   = "00000000|"
					  "16777215|"
					  "00000255|"
					  "00049152|"
					  "16711680|"
					  "00065535|"
					  "12583104|"
					  "16776960";


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CBigDemoDlg dialog

CBigDemoDlg::CBigDemoDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CBigDemoDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CBigDemoDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CBigDemoDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CBigDemoDlg)
	DDX_Control(pDX, IDC_MENU, m_fgMenu);
	DDX_Control(pDX, IDC_DEMO, m_fgDemo);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBigDemoDlg, CDialog)
	//{{AFX_MSG_MAP(CBigDemoDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_SHOWDEMO, OnShowdemo)
	ON_BN_CLICKED(IDC_SHOWHTML, OnShowhtml)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CBigDemoDlg message handlers

BOOL CBigDemoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	

    //~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    // initialize menu (leftmost VSFlexGrid control)
    //

    // set global properties for menu control
    // this could also be done through the properties window, but
    // using code helps document the project.
	//
    m_fgMenu.SetOutlineBar(flexOutlineBarSimple);
    m_fgMenu.SetAllowSelection(FALSE);
    m_fgMenu.SetBackColorBkg(m_fgMenu.GetBackColor());
    m_fgMenu.SetForeColorSel(m_fgMenu.GetBackColor());
    m_fgMenu.SetSheetBorder(m_fgMenu.GetBackColor());
    m_fgMenu.SetEllipsis(flexEllipsisEnd);
    m_fgMenu.SetFixedCols(0);
    m_fgMenu.SetFixedRows(0);
    m_fgMenu.SetCols(1);
    m_fgMenu.SetRows(0);
    m_fgMenu.SetExtendLastCol(TRUE);
    m_fgMenu.SetGridLines(flexGridNone);
    m_fgMenu.SetHighLight(flexHighlightNever);

    // load pictures from icon resources (so we can have transparency)
    //
    // when loading icon resources, CPictureHolder assumes standard size icons.
    // (it uses LoadIcon instead of LoadImage). we want to honor our custom sizes,
    // so we call LoadImage and pass the icon handle to CPictureHolder.
    // 
    HICON hIconFolder = (HICON)LoadImage(AfxGetInstanceHandle(),
						MAKEINTRESOURCE(IDI_FOLDER), IMAGE_ICON, 0, 0, 0);
    HICON hIconItem   = (HICON)LoadImage(AfxGetInstanceHandle(),
						MAKEINTRESOURCE(IDI_ITEM), IMAGE_ICON, 0, 0, 0);
    CPictureHolder picFolder, picItem;
    picFolder.CreateFromIcon(hIconFolder, TRUE);
    picItem.CreateFromIcon(hIconItem, TRUE);

    // package pictures into variants so we can set them with the Cell property
	//
    VARIANT vPicFolder, vPicItem;
    V_VT(&vPicFolder) = V_VT(&vPicItem) = VT_DISPATCH;
    V_DISPATCH(&vPicFolder) = picFolder.GetPictureDispatch();
    V_DISPATCH(&vPicItem) = picItem.GetPictureDispatch();

	// populate the menu
	//
    for (short i = 0; menuOptions[i].name; i++)
    {
        // append the item
        m_fgMenu.AddItem(menuOptions[i].name, vDef);

        // if item contains a colon, it's a folder
        if (strchr(menuOptions[i].name, ':') != NULL) {
            m_fgMenu.SetIsSubtotal(i, TRUE);
            m_fgMenu.SetCell(flexcpFontBold,      COleVariant(i), vDef, vDef, vDef, COleVariant((short)TRUE));
            m_fgMenu.SetCell(flexcpFontUnderline, COleVariant(i), vDef, vDef, vDef, COleVariant((short)TRUE));
            m_fgMenu.SetCell(flexcpPicture,       COleVariant(i), vDef, vDef, vDef, vPicFolder);

        // otherwise, it's a regular item
        } else {
            m_fgMenu.SetCell(flexcpForeColor,     COleVariant(i), vDef, vDef, vDef, COleVariant((long)RGB(0, 0, 125)));
            m_fgMenu.SetCell(flexcpPicture,       COleVariant(i), vDef, vDef, vDef, vPicItem);
        }
    }
    
    // select first item and show the demo
	//
    m_fgMenu.SetRow(1);
	OnShowdemo();

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CBigDemoDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBigDemoDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBigDemoDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnSize(UINT nType, int cx, int cy) 
//
// adjust form layout after resizing
//
void CBigDemoDlg::OnSize(UINT nType, int cx, int cy) 
{
    // allow default processing
	//
    CDialog::OnSize(nType, cx, cy);
	
    // divide client area into two rectangles
	//
    RECT rcMenu, rcDemo;
    GetClientRect(&rcMenu);             // get form's client area
    InflateRect(&rcMenu, -4, -4);       // add a 4-pixel border
    rcDemo = rcMenu;                    // make a copy for the other control
    rcMenu.right = rcMenu.left + 175;   // make the menu control 175 pixels wide
    rcDemo.left = rcMenu.right + 4;     // make the demo control fill the remaining space

    // position buttons below menu
	//
    RECT rcButton = rcMenu;
    rcButton.top = rcButton.bottom - 30;
    CWnd* pButton = GetDlgItem(IDC_SHOWHTML);
    pButton->MoveWindow(&rcButton);
    rcButton.bottom = rcButton.top - 4;
    rcButton.top = rcButton.bottom - 30;
    pButton = GetDlgItem(IDC_SHOWDEMO);
    pButton->MoveWindow(&rcButton);
    
    // adjust menu rect so it doesn't overlap buttons
	//
    rcMenu.bottom = rcButton.top - 4;

    // move VSFlexGrid controls
    m_fgMenu.MoveWindow(&rcMenu);       
    m_fgDemo.MoveWindow(&rcDemo);
}


BEGIN_EVENTSINK_MAP(CBigDemoDlg, CDialog)
    //{{AFX_EVENTSINK_MAP(CBigDemoDlg)
	ON_EVENT(CBigDemoDlg, IDC_MENU, -601 /* DblClick */, OnDblClickMenu, VTS_NONE)
	ON_EVENT(CBigDemoDlg, IDC_MENU, 2 /* RowColChange */, OnRowColChangeMenu, VTS_NONE)
	ON_EVENT(CBigDemoDlg, IDC_DEMO, 32 /* CellButtonClick */, OnCellButtonClickDemo, VTS_I4 VTS_I4)
	ON_EVENT(CBigDemoDlg, IDC_DEMO, 35 /* BeforeScrollTip */, OnBeforeScrollTipDemo, VTS_I4)
	ON_EVENT(CBigDemoDlg, IDC_DEMO, 15 /* DrawCell */, OnDrawCellDemo, VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_I4 VTS_PBOOL)
	ON_EVENT(CBigDemoDlg, IDC_DEMO, 9 /* AfterEdit */, OnAfterEditDemo, VTS_I4 VTS_I4)
	ON_EVENT(CBigDemoDlg, IDC_DEMO, 10 /* BeforeEdit */, OnBeforeEditDemo, VTS_I4 VTS_I4 VTS_PBOOL)
	ON_EVENT(CBigDemoDlg, IDC_DEMO, 31 /* AfterMoveColumn */, OnAfterMoveColumnDemo, VTS_I4 VTS_PI4)
	ON_EVENT(CBigDemoDlg, IDC_DEMO, 30 /* BeforeMoveColumn */, OnBeforeMoveColumnDemo, VTS_I4 VTS_PI4)
	ON_EVENT(CBigDemoDlg, IDC_DEMO, 21 /* OLEDragDrop */, OnOLEDragDropDemo, VTS_PDISPATCH VTS_PI4 VTS_I2 VTS_I2 VTS_R4 VTS_R4)
	ON_EVENT(CBigDemoDlg, IDC_DEMO, 20 /* OLEDragOver */, OnOLEDragOverDemo, VTS_PDISPATCH VTS_PI4 VTS_I2 VTS_I2 VTS_R4 VTS_R4 VTS_PI2)
	//}}AFX_EVENTSINK_MAP
END_EVENTSINK_MAP()


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnDblClickMenu()
// 
// When the user double-clicks on a menu item, show the demo.
//
// When the user double-clicks on a menu heading, expand it and collapse
// all other headers.
//
void CBigDemoDlg::OnDblClickMenu() 
{
    // dbl-clicking on a subtotal (folder) row expands it and collapses all others
    if (m_fgMenu.GetIsSubtotal(m_fgMenu.GetRow())) {
        m_fgMenu.Outline(0);
        m_fgMenu.SetIsCollapsed(m_fgMenu.GetRow(), flexOutlineExpanded);
        return;
    }
    
    // dbl-clicking on a regular item shows the demo for that item
    OnShowdemo();
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnRowColChangeMenu() 
//
// Update caption on demo button to reflect the current selection.
//
// Enable button if an item is selected, disable it if a heading is 
// selected.
//
void CBigDemoDlg::OnRowColChangeMenu() 
{
    CString str;
    CWnd* pButton = GetDlgItem(IDC_SHOWDEMO);
    
    // if the item is a heading, disable the button
	//
    if (m_fgMenu.GetIsSubtotal(m_fgMenu.GetRow())) {
        pButton->SetWindowText("Show Me");
        pButton->EnableWindow(FALSE);
		str.Format("Big Demo: %s", menuOptions[m_fgMenu.GetRow()].name);
		SetWindowText((LPCSTR)str);
        return;
    }

    // otherwise, enable button and update its caption
	//
    str.Format("Show %s", m_fgMenu.GetText());
    pButton->SetWindowText((LPCSTR)str);
    pButton->EnableWindow(TRUE);
	str.Format("Big Demo: %s", menuOptions[m_fgMenu.GetRow()].help);
	SetWindowText((LPCSTR)str);
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnShowdemo() 
// 
// Display currently selected demo on m_fgDemo control.
//
void CBigDemoDlg::OnShowdemo() 
{
    // freeze to avoid any flicker
	//
	m_fgDemo.SetRedraw(FALSE);

	// save id of current demo
	// we are doing several demos with a single control, and some
	// of the event handlers need to know what the current demo is
	// in order to behave properly.
	//
	m_iCurrentDemo = menuOptions[m_fgMenu.GetRow()].demoId;

    // show selected demo
	//
    switch (m_iCurrentDemo) {

        // Editing
        case 1:     DemoEditMask();     break;
        case 2:     DemoPopups();       break;
        case 3:     DemoCombos();       break;

        // Formatting
        case 5:     DemoFormat();		break;
        case 6:     DemoCellProp();		break;

		// Goodies
        case 14:	DemoAutoSearch();	break;
        case 15:	DemoExplorerBar();	break;
        case 16:	DemoScrollTips();	break;
        case 17:	DemoOwnerDraw();	break;

		// Outlines/Totals
        case 19:	DemoSalesReport();	break;
		case 20:	DemoCustomTree();	break;

		// Drag/drop
		case 22:	DemoOleDDAuto();	break;
		case 23:	DemoOleDDManual();	break;
    }

    // demo is up, we're ready to show it again
	//
	m_fgDemo.SetRedraw(TRUE);
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnShowhtml() 
// 
// Render demo control into an HTML file and display it in browser.
//
void CBigDemoDlg::OnShowhtml() 
{
    // create file name for HTML output
	//
    char strFileName[256];
    GetModuleFileName(NULL, strFileName, 255);
    LPSTR ptr = strrchr(strFileName, '\\');
    if (ptr) ptr[1] = 0;
    strcat(strFileName, "FlexDemo.htm");

    // create HTML file
	// the SaveGridToHTML function is implemented in FlexUtil.cpp
	//
    if (!SaveGridToHTML(&m_fgDemo, strFileName)) return;
    
    // display in browser
	//
    ShellExecute(m_hWnd, NULL, strFileName, NULL, NULL, SW_SHOWNORMAL);
}
 

    
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoSetDefaults() 
// 
// Initialize the demo control to a clean state before each demo
// parties with it.
//
void CBigDemoDlg::DemoSetDefaults() 
{
    VARIANT vDef;
    V_VT(&vDef) = VT_ERROR;
    m_fgDemo.BindToArray(vDef, vDef, vDef, vDef, vDef);
    m_fgDemo.SetRows(0);
    m_fgDemo.SetCols(0);
    m_fgDemo.SetScrollTrack(FALSE);
    m_fgDemo.SetExplorerBar(flexExNone);
    m_fgDemo.SetAutoSearch(flexSearchNone);
    m_fgDemo.SetEditable(FALSE);
    m_fgDemo.SetAllowUserResizing(flexResizeNone);
    m_fgDemo.SetSelectionMode(flexSelectionFree);
    m_fgDemo.SetOutlineBar(flexOutlineBarNone);
    m_fgDemo.SetOLEDragMode(flexOLEDragManual);
    m_fgDemo.SetOLEDropMode(flexOLEDropNone);
    m_fgDemo.SetScrollTips(FALSE);
    m_fgDemo.SetOwnerDraw(flexODNone);
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoFillColumn(int col, LPSTR list) 
// 
// Fills a grid column with random data from a string containing
// an arbitrary number of items separated by pipes (e.g. "Abc|Def").
//
// This is used by most demo methods to populate the control.
//
void CBigDemoDlg::DemoFillColumn(int col, LPSTR list)
{
    // count items
	//
    short count = 1;
    for (LPSTR ptr = list; ptr && *ptr; ptr = CharNext(ptr))
        if (*ptr == '|') count++;

    // loop through rows
	//
    for (long row = m_fgDemo.GetFixedRows(); row < m_fgDemo.GetRows(); row++) {

        // select a random item
        int item = rand() % count;
        for (ptr = list; item; ptr = CharNext(ptr))
            if (*ptr == '|') item--;
        for (int len = 0; ptr[len] && ptr[len] != '|'; len++);

        // copy item to control
		static char strItem[100];
		strncpy(strItem, ptr, len);
		strItem[len] = 0;
        m_fgDemo.SetTextMatrix(row, col, strItem);
    }
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoEditMask() 
// 
// Shows how to use EditMasks to facilitate data entry/validation.
//
void CBigDemoDlg::DemoEditMask() 
{
    // reset the control
	//
    DemoSetDefaults();
    
    // override some properties
	//
    m_fgDemo.SetAllowUserResizing(flexResizeBoth);
    m_fgDemo.SetExtendLastCol(TRUE);
    m_fgDemo.SetEditable(TRUE);
    
    // fill the control with data
	//
    m_fgDemo.SetRows(50);
    m_fgDemo.SetFixedRows(1);
    m_fgDemo.SetCols(6);
    
    m_fgDemo.SetTextMatrix(0, 0, "First Name");
    DemoFillColumn(0, slFirstNames);

    m_fgDemo.SetTextMatrix(0, 1, "Last Name");
    DemoFillColumn(1, slLastNames);
    
    m_fgDemo.SetTextMatrix(0, 2, "Office Phone");
    m_fgDemo.SetColEditMask(2, "(###) 000-0000");
    DemoFillColumn(2, slPhones);
    
    m_fgDemo.SetTextMatrix(0, 3, "Home Phone");
    m_fgDemo.SetColEditMask(3, "(###) 000-0000");
    DemoFillColumn(3, slPhones);
    
    m_fgDemo.SetTextMatrix(0, 4, "Credit Card");
    m_fgDemo.SetColEditMask(4, "0000 0000 0000 0000;;*");
    DemoFillColumn(4, slCards);
    
    m_fgDemo.SetTextMatrix(0, 5, "Hire Date");
    m_fgDemo.SetColDataType(3, flexDTDate);
    m_fgDemo.SetColFormat(5, "Medium Date");
    m_fgDemo.SetColEditMask(5, "00->LLL-00");
    DemoFillColumn(5, slDates);
    
    // autosize so all columns fit
	//
    VARIANT vDef;
    V_VT(&vDef) = VT_ERROR;
    m_fgDemo.AutoSize(0, COleVariant((short)(m_fgDemo.GetCols() - 1)), vDef, COleVariant((short)300));
    
    // done, let user play with it
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoPopups() 
// 
// Shows how to use Popups to allow custom cell editors.
//
// This is done by setting ColComboList (or ComboList) to an ellipsis,
// then handling the CellButtonClick event.
//
// In this case, we are popping up a standard File Open dialog.
//
void CBigDemoDlg::DemoPopups() 
{
    // reset the control
	//
    DemoSetDefaults();
    
    // override some properties
	//
    m_fgDemo.SetAllowUserResizing(flexResizeBoth);
    m_fgDemo.SetExtendLastCol(TRUE);
    m_fgDemo.SetEditable(TRUE);
    m_fgDemo.SetExplorerBar(flexExSortAndMove);
    
    // fill the control with data
	//
    m_fgDemo.SetRows(50);
    m_fgDemo.SetFixedRows(1);
    m_fgDemo.SetCols(6);
    
    m_fgDemo.SetTextMatrix(0, 0, "File Name");
    m_fgDemo.SetColComboList(0, "..."); // file picker popup
    DemoFillColumn(0, slFileNames);

    m_fgDemo.SetTextMatrix(0, 1, "File Size");
    m_fgDemo.SetColFormat(1, "#,###");
    DemoFillColumn(1, slFileSizes);
    
    m_fgDemo.SetTextMatrix(0, 2, "Read Only");
    m_fgDemo.SetColDataType(2, flexDTBoolean);

    m_fgDemo.SetTextMatrix(0, 3, "Created");
    m_fgDemo.SetColComboList(3, "..."); // date picker popup
    m_fgDemo.SetColDataType(3, flexDTDate);
    m_fgDemo.SetColFormat(3, "Short Date");
    DemoFillColumn(3, slDates);
    
    m_fgDemo.SetTextMatrix(0, 4, "Modified");
    m_fgDemo.SetColComboList(4, "..."); // date picker popup
    m_fgDemo.SetColDataType(4, flexDTDate);
    m_fgDemo.SetColFormat(4, "Medium Date");
    DemoFillColumn(4, slDates);
    
    m_fgDemo.SetTextMatrix(0, 5, "Accessed");
    m_fgDemo.SetColComboList(5, "..."); // date picker popup
    m_fgDemo.SetColDataType(5, flexDTDate);
    m_fgDemo.SetColFormat(5, "yyyy.mm.dd");
    DemoFillColumn(5, slDates);
    
    // autosize so all columns fit
	//
    VARIANT vDef;
    V_VT(&vDef) = VT_ERROR;
    m_fgDemo.AutoSize(0, COleVariant((short)(m_fgDemo.GetCols() - 1)), vDef, COleVariant((short)300));
    
    // done, let user play with it
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// OnCellButtonClickDemo
//
// EVENT HANDLER:
// Called when the user clicks on a popup button on the demo grid
//
void CBigDemoDlg::OnCellButtonClickDemo(long Row, long Col) 
{
    switch (m_fgDemo.GetColDataType(Col)) {
        
        // pick a date
		//
        case flexDTDate:
            MessageBox("TODO: Build a calendar...");
            break;

        // pick a file
		//
        default:
            CFileDialog fd(TRUE, "*", m_fgDemo.GetTextMatrix(Row, Col));
            if (fd.DoModal() != IDOK) return;
            m_fgDemo.SetTextMatrix(Row, Col, (LPCSTR)fd.GetFileName());
    }
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoCombos() 
// 
// Shows how to use complex (multi-collumn/masked) combo boxes.
//
void CBigDemoDlg::DemoCombos() 
{
    // reset the control
	//
    DemoSetDefaults();

    // override some properties
	//
    m_fgDemo.SetAllowUserResizing(flexResizeBoth);
    m_fgDemo.SetExtendLastCol(TRUE);
    m_fgDemo.SetEditable(TRUE);
    
    // fill the control with data
	//
    m_fgDemo.SetRows(50);
    m_fgDemo.SetFixedRows(1);
    m_fgDemo.SetCols(3);
    
    m_fgDemo.SetTextMatrix(0, 0, "Name");
    m_fgDemo.SetColComboList(0, slComboNames);
    DemoFillColumn(0, slLastNames);
    
    m_fgDemo.SetTextMatrix(0, 1, "Home Phone");
    m_fgDemo.SetColEditMask(1, "(###) 000-0000");
    m_fgDemo.SetColComboList(1, slComboPhones);
    DemoFillColumn(1, slPhones);
    
    m_fgDemo.SetTextMatrix(0, 2, "Office Phone");
    m_fgDemo.SetColEditMask(2, "(###) 000-0000");
    m_fgDemo.SetColComboList(2, slComboPhones);
    DemoFillColumn(2, slPhones);
    
    // make all columns same width
	//
    m_fgDemo.SetColWidth(-1, m_fgDemo.GetClientWidth() / m_fgDemo.GetCols());
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoFormat() 
// 
// Shows how to format cells containing numeric, boolean, and date 
// formats.
//
void CBigDemoDlg::DemoFormat() 
{
    // reset the control
	//
    DemoSetDefaults();

    // override some properties
	//
    m_fgDemo.SetAllowUserResizing(flexResizeBoth);
    m_fgDemo.SetExtendLastCol(TRUE);
    m_fgDemo.SetExplorerBar(flexExSortAndMove);
    m_fgDemo.SetEditable(TRUE);

    // fill the control with data
	//
    m_fgDemo.SetRows(50);
    m_fgDemo.SetFixedRows(1);
    m_fgDemo.SetCols(6);
    
    m_fgDemo.SetTextMatrix(0, 0, "File Name");
    DemoFillColumn(0, slFileNames);

    m_fgDemo.SetTextMatrix(0, 1, "Size (#,###)");
    m_fgDemo.SetColFormat(1, "#,###");
    DemoFillColumn(1, slFileSizes);
    
    m_fgDemo.SetTextMatrix(0, 2, "Boolean");
    m_fgDemo.SetColDataType(2, flexDTBoolean);

    m_fgDemo.SetTextMatrix(0, 3, "Short Date");
    m_fgDemo.SetColDataType(3, flexDTDate);
    m_fgDemo.SetColFormat(3, "Short Date");
    DemoFillColumn(3, slDates);
    
    m_fgDemo.SetTextMatrix(0, 4, "Medium Date");
    m_fgDemo.SetColDataType(4, flexDTDate);
    m_fgDemo.SetColFormat(4, "Medium Date");
    DemoFillColumn(4, slDates);
    
    m_fgDemo.SetTextMatrix(0, 5, "Custom Date");
    m_fgDemo.SetColDataType(5, flexDTDate);
    m_fgDemo.SetColFormat(5, "yyyy.mm.dd");
    DemoFillColumn(5, slDates);
    
    // autosize so all columns fit
	//
    VARIANT vDef;
    V_VT(&vDef) = VT_ERROR;
    m_fgDemo.AutoSize(0, COleVariant((short)(m_fgDemo.GetCols() - 1)), vDef, COleVariant((short)300));
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoCellProp() 
// 
// Shows how to format ranges using the Cell property.
//
// The Cell property is quite powerful: it allows you to set and retrieve
// virtually anything for a cell or range of cells.
//
// The syntax generated by VC++ is a little awkward, because many of the 
// parameters are optional and therefore are declared as VARIANTS.
//
// Normally, you would define your own wrapper for the SetCell and GetCell
// methods. This was not done here to keep the code as explicit as 
// possible.
//
void CBigDemoDlg::DemoCellProp() 
{
    // reset the control
	//
    DemoSetDefaults();

    // override some properties
	//
    m_fgDemo.SetAllowUserResizing(flexResizeBoth);
    m_fgDemo.SetExtendLastCol(TRUE);
    m_fgDemo.SetExplorerBar(flexExSortAndMove);
    
    // fill the control with data
	//
    m_fgDemo.SetRows(50);
    m_fgDemo.SetFixedRows(1);
    m_fgDemo.SetCols(4);

    m_fgDemo.SetTextMatrix(0, 0, "File Name");
    DemoFillColumn(0, slFileNames);

    m_fgDemo.SetTextMatrix(0, 1, "File Size");
    m_fgDemo.SetColFormat(1, "#,###");
    DemoFillColumn(1, slFileSizes);

    m_fgDemo.SetTextMatrix(0, 2, "Read Only");
    m_fgDemo.SetColDataType(2, flexDTBoolean);

    m_fgDemo.SetTextMatrix(0, 3, "Created");
    m_fgDemo.SetColDataType(3, flexDTDate);
    m_fgDemo.SetColFormat(3, "Short Date");
    DemoFillColumn(3, slDates);
    
    // load pictures from icon resources (so we can have transparency)
    //
    // when loading icon resources, CPictureHolder assumes standard size icons.
    // (it uses LoadIcon instead of LoadImage). we want to honor our custom sizes,
    // so we call LoadImage and pass the icon handle to CPictureHolder.
    // 
    HICON hCellPic = (HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_CELLPIC), IMAGE_ICON, 0, 0, 0);
    CPictureHolder picCell;
    picCell.CreateFromIcon(hCellPic, TRUE);

    // package pictures into variants so we can use the Cell property
	//
    VARIANT vCellPic;
    V_VT(&vCellPic) = VT_DISPATCH;
    V_DISPATCH(&vCellPic) = picCell.GetPictureDispatch();

	// make variants to select the range
	//
	COleVariant vCol0((short)0);
	COleVariant vCol1((short)1);
	COleVariant vRow1((long)m_fgDemo.GetFixedRows());
	COleVariant vRow2((long)(m_fgDemo.GetRows() - 1));

    // use the Cell property to put pictures and
    // change the background color on column 0:
    // this is quick: there's no need to select the cells first
	//
    m_fgDemo.SetCell(flexcpBackColor,
					 vRow1, vCol0, vRow2, vCol0, 
					 COleVariant((long)RGB(255, 255, 0)));
    m_fgDemo.SetCell(flexcpPictureAlignment,
					 vRow1, vCol0, vRow2, vCol0, 
					 COleVariant((short)flexPicAlignLeftCenter));
    m_fgDemo.SetCell(flexcpPicture,
					 vRow1, vCol0, vRow2, vCol0, 
		             vCellPic);

    // change the font on column 0
	// make it 7 point, bold, underlined
	//
    m_fgDemo.SetCell(flexcpFontBold, vRow1, vCol0, vRow2, vCol0, COleVariant((short)TRUE));
    m_fgDemo.SetCell(flexcpFontSize, vRow1, vCol0, vRow2, vCol0, COleVariant((float)7));
    m_fgDemo.SetCell(flexcpFontUnderline, vRow1, vCol0, vRow2, vCol0, COleVariant((short)TRUE));
    
    // copy the new font to column 1
	//
	COleVariant vFont;
	vFont = m_fgDemo.GetCell(flexcpFont, vRow1, vCol0, vRow1, vCol0);
    m_fgDemo.SetCell(flexcpFont, vRow1, vCol1, vRow2, vCol1, vFont);
    
    // autosize so all columns fit
	//
    VARIANT vDef;
    V_VT(&vDef) = VT_ERROR;
    m_fgDemo.AutoSize(0, COleVariant((short)(m_fgDemo.GetCols() - 1)), vDef, COleVariant((short)500));
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoAutoSearch() 
// 
// Shows how to use the AutoSearch property.
//
// The selection will move as the user types into the control.
//
void CBigDemoDlg::DemoAutoSearch() 
{
    // reset the control
	//
    DemoSetDefaults();

    // override some properties
	//
    m_fgDemo.SetAllowUserResizing(flexResizeBoth);
    m_fgDemo.SetExtendLastCol(TRUE);
    m_fgDemo.SetAutoSearch(flexSearchFromCursor);

    // fill the control with data
	//
    m_fgDemo.SetRows(150);
    m_fgDemo.SetFixedRows(1);
    m_fgDemo.SetCols(4);
    
    m_fgDemo.SetTextMatrix(0, 0, "First Name");
    DemoFillColumn(0, slFirstNames);

    m_fgDemo.SetTextMatrix(0, 1, "Last Name");
    DemoFillColumn(1, slLastNames);
    
    m_fgDemo.SetTextMatrix(0, 2, "Office Phone");
    m_fgDemo.SetColEditMask(2, "(###) 000-0000");
    DemoFillColumn(2, slPhones);
    
    m_fgDemo.SetTextMatrix(0, 3, "Home Phone");
    m_fgDemo.SetColEditMask(3, "(###) 000-0000");
    DemoFillColumn(3, slPhones);
    
    // autosize so all columns fit
	//
    VARIANT vDef;
    V_VT(&vDef) = VT_ERROR;
    m_fgDemo.AutoSize(0, COleVariant((short)(m_fgDemo.GetCols() - 1)), vDef, COleVariant((short)300));
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoExplorerBar() 
// 
// Shows how to use the ExplorerBar property.
//
// Setting it to "flexExSortAndMove" allows users to sort columns by
// clicking on their headings, and to rearrange the columns by dragging
// the headings around.
//
void CBigDemoDlg::DemoExplorerBar() 
{
    // save some typing...
    DemoAutoSearch();
    m_fgDemo.SetExplorerBar(flexExSortAndMove);
    m_fgDemo.SetAutoSearch(flexSearchNone);
}

        
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoScrollTips() 
// 
// Shows how to implement ScrollTips.
//
// ScrollTips are useful when there are many rows: they show a tooltip
// next to the vertical scroll bar while the user scrolls.
//
// The text in the tooltip is defined in the BeforeScrollTip event, and
// normally contains information about the row that will become visible
// when the user releases the scroll button.
//
void CBigDemoDlg::DemoScrollTips() 
{
    // save some typing...
	//
    DemoAutoSearch();
    m_fgDemo.SetAutoSearch(flexSearchNone);

    // turn on ScrollTips
	//
	// note that for this to work, we also need to trap the
	// BeforeScrollTip event
	//
    m_fgDemo.SetScrollTrack(FALSE);
    m_fgDemo.SetScrollTips(TRUE);
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// OnBeforeScrollTipDemo
//
// EVENT HANDLER:
// Called when the FlexGrid needs text for a scroll tip.
// The Row parameter contains the number of the row that will appear
// at the top of the control when the scroll button is released.
//
void CBigDemoDlg::OnBeforeScrollTipDemo(long Row) 
{
	// build message to display
	CString strMsg;
	strMsg.Format(" Row %d: %s ", Row, m_fgDemo.GetTextMatrix(Row, 0));
    m_fgDemo.SetScrollTipText((LPCSTR)strMsg);
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoOwnerDraw() 
// 
// Shows how to implement OwnerDraw cells (custom painting).
//
// The user selects two colors on columns 0 and 1, and we trap the
// DrawCell event to paint a gradient between the two colors on column 2.
//
// This demo also shows how to use translated combo boxes. The grid
// actually stores the RGB values for the colors, but displays their 
// names instead.
//
void CBigDemoDlg::DemoOwnerDraw() 
{
    // reset the control
	//
    DemoSetDefaults();

    // override some properties
	//
    m_fgDemo.SetAllowUserResizing(flexResizeBoth);
    m_fgDemo.SetEditable(TRUE);
    m_fgDemo.SetExtendLastCol(TRUE);
    m_fgDemo.SetOwnerDraw(flexODOver);

    // fill the control with data (start with random colors)
	//
    m_fgDemo.SetRows(25);
    m_fgDemo.SetFixedRows(1);
    m_fgDemo.SetCols(3);
    
    m_fgDemo.SetTextMatrix(0, 0, "Color 1");
	m_fgDemo.SetColComboList(0, slColors);
	DemoFillColumn(0, slRGBColors);

    m_fgDemo.SetTextMatrix(0, 1, "Color 2");
	m_fgDemo.SetColComboList(1, slColors);
	DemoFillColumn(1, slRGBColors);
    
    m_fgDemo.SetTextMatrix(0, 2, "Gradient");
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnBeforeEditDemo(long Row, long Col, BOOL FAR* Cancel) 
//
// EVENT HANDLER
// Prevent user from editing the gradient column.
//
void CBigDemoDlg::OnBeforeEditDemo(long Row, long Col, BOOL FAR* Cancel) 
{
	// ignore unless this is the OwnerDraw demo
	//
	if (m_iCurrentDemo != 17) return;
	
	// prevent editing the gradient column (#2)
	//
	if (Col == 2) *Cancel = TRUE;
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnAfterEditDemo(long Row, long Col) 
// 
// EVENT HANDLER
// After editing one of the colors, repaint the gradient.
//
void CBigDemoDlg::OnAfterEditDemo(long Row, long Col) 
{
	// ignore unless this is the OwnerDraw demo
	//
	if (m_iCurrentDemo != 17) return;

	// otherwise, refresh the control to show the changes
	//
	m_fgDemo.Refresh();
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnDrawCellDemo(...)
// 
// EVENT HANDLER
// Code to draw a color gradient in a cell.
//
void CBigDemoDlg::OnDrawCellDemo(long hDC, long Row, long Col, 
								 long Left, long Top, long Right, long Bottom, 
								 BOOL FAR* Done) 
{
	// we are only interested in painting the gradient column (#2)
	//
	if (Col != 2 || Row == 0) {
		*Done = FALSE;
		return;
	}

	// make sure the cell is big enough for us to paint into
	//
	if (Right - Left < 15 || Bottom - Top < 8) return;

	// cast hdc into a handle and save back color
	//
	HDC hdc = (HDC)hDC;
	long clr = SetBkColor(hdc, 0);

	// get rectangle to draw into
	//
	RECT rc;
	SetRect(&rc, Left, Top, Right, Bottom);
	InflateRect(&rc, -5, -3);
    
	// draw black frame around gradient
	//
    SetBkColor(hdc, 0);
	ExtTextOut(hdc, rc.left, rc.top, ETO_OPAQUE, &rc, " ", 1, NULL);
	InflateRect(&rc, -1, -1);
            
	// get colors (by default, it's all black)
	// remember: these are translated combos, so
	//   the value displayed is the name of the color, and
	//   the value stored in the grid is the corresponding RGB value.
	// see the definition of "slColors" for details.
	//
	long lColor1 = atol(m_fgDemo.GetTextMatrix(Row, 0));
	long lColor2 = atol(m_fgDemo.GetTextMatrix(Row, 1));
    
    // break colors into their RGB components
	//
	long r1 = (lColor1 & 0xff);        
	long g1 = ((lColor1 >>  8) & 0xff);
	long b1 = ((lColor1 >> 16) & 0xff);
	long r2 = (lColor2 & 0xff);        
	long g2 = ((lColor2 >>  8) & 0xff);
	long b2 = ((lColor2 >> 16) & 0xff);
            
	// paint gradient
	//
    RECT rcBand;
	rcBand = rc;
	for (long l = rc.left; l < rc.right; l += 3) {
		long rg = r1 + (l - rc.left) * (r2 - r1) / (rc.right - rc.left);
        long gg = g1 + (l - rc.left) * (g2 - g1) / (rc.right - rc.left);
        long bg = b1 + (l - rc.left) * (b2 - b1) / (rc.right - rc.left);
        SetBkColor(hdc, RGB(rg, gg, bg));
        rcBand.left = l;
	    rcBand.right = rcBand.left + 3;
		if (rcBand.right >= rc.right) rcBand.right = rc.right;
        ExtTextOut(hdc, rcBand.left, rcBand.top, ETO_OPAQUE, &rcBand, " ", 1, NULL);
	}
            
	// done, clean up and quit
	//
    SetBkColor(hdc, clr);
    *Done = TRUE;
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoSalesReport() 
// 
// Create a report with totals and cell merging.
//
// We also set the ExplorerBar property so the user can drag columns 
// around. The report is automatically regenerated after columns are 
// moved.
//
// This demo also shows how you can control column dragging by the user:
// in this case, we trap the BeforeMoveColumn and prevent the column that
// contains the sales figures from being moved anywhere.
//
void CBigDemoDlg::DemoSalesReport()
{
    // reset the control
	//
    DemoSetDefaults();

    // override some properties
	//
    m_fgDemo.SetAllowUserResizing(flexResizeBoth);
    m_fgDemo.SetEditable(TRUE);
    m_fgDemo.SetExtendLastCol(TRUE);
    m_fgDemo.SetExplorerBar(flexExMove);

    // fill the control with data
	//
    m_fgDemo.SetRows(50);
    m_fgDemo.SetFixedRows(1);
    m_fgDemo.SetCols(4);
    
    m_fgDemo.SetTextMatrix(0, 0, "Product");
    DemoFillColumn(0, slProduct);

    m_fgDemo.SetTextMatrix(0, 1, "Associate");
    DemoFillColumn(1, slLastNames);
    
    m_fgDemo.SetTextMatrix(0, 2, "Region");
    DemoFillColumn(2, "North|South|East|West");
    
    m_fgDemo.SetTextMatrix(0, 3, "Sales");
    m_fgDemo.SetColFormat(3, "#,###.##");
    DemoFillColumn(3, slFileSizes); // fake it... they're just numbers

    // sort and total
    DemoSortAndTotal();
}

		
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoSortAndTotal() 
// 
// Helper function to sort the report and calculate subtotals.
//
// This gets called every time the user drags a column to a new position.
//
void CBigDemoDlg::DemoSortAndTotal()
{
    // define variant to use when omitting optional parameters
	//
	VARIANT vDef;
    V_VT(&vDef) = VT_ERROR;

    // define shorthand variants
	//
	COleVariant vG(-1L);
	COleVariant v0(0L);
	COleVariant v1(1L);
	COleVariant v2(2L);
	COleVariant v3(3L);
	COleVariant vF("#,");
	COleVariant vWhite((long)RGB(255,255,255));
	COleVariant vBlack((long)RGB(1,1,1));
	COleVariant vGray1((long)RGB(60,60,60));
	COleVariant vGray2((long)RGB(120,120,120));
	COleVariant vGray3((long)RGB(192,192,192));

    // freeze to avoid flicker
	//
	m_fgDemo.SetRedraw(FALSE);

    // update sort
	//
    m_fgDemo.Select(1, 0, COleVariant((short)1), COleVariant((short)(m_fgDemo.GetCols() - 1)));
    m_fgDemo.SetSort(flexSortGenericAscending);
    
    // update subtotals
	//
    m_fgDemo.SetOutlineCol(0);
    m_fgDemo.SetOutlineBar(flexOutlineBarComplete);
    m_fgDemo.SetSubtotalPosition(flexSTAbove);
    m_fgDemo.Subtotal(flexSTClear, vDef, vDef, vDef, vDef, vDef, vDef, vDef, vDef, vDef);
    m_fgDemo.Subtotal(flexSTSum, vG, v3, vF, vBlack, vWhite, vG, vDef, v0, v0);
    m_fgDemo.Subtotal(flexSTSum, v0, v3, vF, vGray1, vWhite, vG, vDef, v0, v0);
    m_fgDemo.Subtotal(flexSTSum, v1, v3, vF, vGray2, vWhite, v0, vDef, v0, v0);
    m_fgDemo.Subtotal(flexSTSum, v2, v3, vF, vGray3, vWhite, v0, vDef, v0, v0);
    
    // update merging
	//
    m_fgDemo.SetMergeCells(flexMergeRestrictAll);
    m_fgDemo.SetMergeCol(0, TRUE);
    m_fgDemo.SetMergeCol(1, TRUE);
    m_fgDemo.SetMergeCol(2, TRUE);
    m_fgDemo.SetMergeCol(3, TRUE);

    // auto size
	//
    m_fgDemo.AutoSize(0, COleVariant((short)(m_fgDemo.GetCols() - 1)), vDef, COleVariant((short)300));

    // show it again
	//
	m_fgDemo.SetRedraw(TRUE);
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnBeforeMoveColumnDemo(long Col, long FAR* Position) 
// 
// EVENT HANDLER:
// The last column in the sales report must be the sales figures;
// so we prevent anyone else from becoming the last column.
//
void CBigDemoDlg::OnBeforeMoveColumnDemo(long Col, long FAR* Position) 
{
	// ignore unless this is the SalesReport demo
	//
	if (m_iCurrentDemo != 19) return;

	// column 3 is for sales figures
	// if anyone elase tries to take it, they move to position 2
	// instead.
	//
	if (Col == 3) {
		*Position = 3;
		return;
	}
	if (*Position == 3) {
		*Position = 2;
	}
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnAfterMoveColumnDemo(long Col, long FAR* Position) 
// 
// EVENT HANDLER:
// After moving a column, resort and get new subtotals.
//
void CBigDemoDlg::OnAfterMoveColumnDemo(long Col, long FAR* Position) 
{
	// ignore unless this is the SalesReport demo
	//
	if (m_iCurrentDemo != 19) return;

	// update the report
	//
	DemoSortAndTotal();
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoCustomTree() 
// 
// Create a custom outline structure. (Also see the code that 
// creates the menu on this demo).
//
void CBigDemoDlg::DemoCustomTree()
{
    // create a dummy variant we can use when we want to omit optional parameters
	//
    VARIANT vDef;
    V_VT(&vDef) = VT_ERROR;

    // load pictures from icon resources (so we can have transparency)
    //
    // when loading icon resources, CPictureHolder assumes standard size icons.
    // (it uses LoadIcon instead of LoadImage). we want to honor our custom sizes,
    // so we call LoadImage and pass the icon handle to CPictureHolder.
    // 
    HICON hIconFolder = (HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_FOLDER), IMAGE_ICON, 0, 0, 0);
    HICON hIconItem = (HICON)LoadImage(AfxGetInstanceHandle(), MAKEINTRESOURCE(IDI_ITEM), IMAGE_ICON, 0, 0, 0);
    CPictureHolder picFolder, picItem;
    picFolder.CreateFromIcon(hIconFolder, TRUE);
    picItem.CreateFromIcon(hIconItem, TRUE);

    // package pictures into variants so we can use the Cell property
	//
    VARIANT vPicFolder, vPicItem;
    V_VT(&vPicFolder) = V_VT(&vPicItem) = VT_DISPATCH;
    V_DISPATCH(&vPicFolder) = picFolder.GetPictureDispatch();
    V_DISPATCH(&vPicItem) = picItem.GetPictureDispatch();

    // reset the control
	//
    DemoSetDefaults();

    // override some properties
	//
    m_fgDemo.SetAllowUserResizing(flexResizeBoth);
    m_fgDemo.SetEditable(TRUE);
    m_fgDemo.SetExtendLastCol(TRUE);
    m_fgDemo.SetExplorerBar(flexExMove);
    m_fgDemo.SetOutlineBar(flexOutlineBarComplete);
    m_fgDemo.SetSubtotalPosition(flexSTAbove);
    m_fgDemo.SetRows(1);
    m_fgDemo.SetFixedRows(1);
    m_fgDemo.SetCols(3);
    m_fgDemo.SetOutlineCol(0); //<< set this after setting the number of columns

    // set up headings
	//
    m_fgDemo.SetTextMatrix(0, 0, "Heading");
    m_fgDemo.SetTextMatrix(0, 1, "Row");
    m_fgDemo.SetTextMatrix(0, 2, "Random");
    
    // fill the control with data
	//
	CString str;
	short currlevel, level = 0;
    for (long row = 1; row < 150; row++) {
        
        // decide randomly whether to add a subtotal
        if (m_fgDemo.GetRows() <= 2 || (rand() % 100) < 40) {
        
            // add an item, make it a subtotal
			str.Format("Branch Level %d", level);
			m_fgDemo.AddItem(str, vDef);
            m_fgDemo.SetIsSubtotal(row, TRUE);
            m_fgDemo.SetRowOutlineLevel(row, level);
            m_fgDemo.SetCell(flexcpPicture, COleVariant(row), COleVariant(0L), vDef, vDef, vPicFolder);
            
            // decide whether to go deeper or shallower
			currlevel = level;
            if (rand() % 100 < 50 && level < 10) {
                level++;
			} else if (rand() % 100 < 50 && level > 0) {
                level--;
			}
        
        // add a regular item
        } else {
			str.Format("Data on Level %d\t%d\t%d", currlevel, row, rand());
			m_fgDemo.AddItem(str, vDef);
            m_fgDemo.SetCell(flexcpPicture, COleVariant(row), COleVariant(0L), vDef, vDef, vPicItem);
		}
    }
    
    // add some more data just for kicks
	//
    for (; row < 160; row++) {
		str.Format("Data on Level %d\t%d\t%d", currlevel, row, rand());
		m_fgDemo.AddItem(str, vDef);
        m_fgDemo.SetCell(flexcpPicture, COleVariant(row), COleVariant(0L), vDef, vDef, vPicItem);
    }
    
    // autosize so all columns fit
	//
    m_fgDemo.AutoSize(0, COleVariant((short)(m_fgDemo.GetCols() - 1)), vDef, COleVariant((short)300));
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoOleDDAuto() 
// 
// Shows how to use automatic OLE drag and drop.
//
void CBigDemoDlg::DemoOleDDAuto()
{
    // save some typing...
	//
    DemoAutoSearch();
    m_fgDemo.SetExplorerBar(flexExSortAndMove);
    m_fgDemo.SetAutoSearch(flexSearchNone);

	// this allow users to drag selections by the edges.
	// they can drop the selection into OLE drop targets
	// such as Excel, Word, or VSFlexGrid.
	//
	m_fgDemo.SetOLEDragMode(flexOLEDragAutomatic);

	// this allow users to drop selections into the from OLE drag sources 
	// such as Excel, Word, or VSFlexGrid into the control.
	//
	m_fgDemo.SetOLEDropMode(flexOLEDropAutomatic);

	// you can also drag from one part of the control to another
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::DemoOleDDManual() 
// 
// Shows how to use manual OLE drag and drop. This involves more work
// than the automatic option, but you get more control over the whole
// process.
//
// This demo allows you to drag files from the Explorer and drop them
// onto the control. The control will open the file and copy its first 
// ten lines.
//
// In manual mode, you need to respond to OLE drag drop events. The data 
// being dragged and dropped is encapsulated in a data object, which
// is passed as a parameter in most OleDragDrop events.
//
// To make the data object easy to use, FlexUtil.h defines a 
// CvsFlexGridDataObject with methods that allow you to query and set
// data on the object.
//
void CBigDemoDlg::DemoOleDDManual()
{
    // save some typing...
	//
    DemoAutoSearch();
    m_fgDemo.SetExplorerBar(flexExSortAndMove);
    m_fgDemo.SetAutoSearch(flexSearchNone);

	// set the properties
	//
	m_fgDemo.SetOLEDragMode(flexOLEDragManual);
	m_fgDemo.SetOLEDropMode(flexOLEDropManual);
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnOLEDragOverDemo(...)
// 
// The user is dragging a selection over the control.
//
// If the data object being dragged contains files, show some
// feedback so the user knows he can drop the data here.
//
// The most interesting thing going on here is the way the Data parameter
// is wrapped in a CvsFlexGridDataObject object.
//
void CBigDemoDlg::OnOLEDragOverDemo(LPDISPATCH FAR* Data, long FAR* Effect, 
									short Button, short Shift, float X, float Y, short FAR* State) 
{
	// ignore unless this is the OLE drag drop demo
	//
	if (m_iCurrentDemo != 23) return;

	// wrap data object into a class that is easy to use
	//
	CvsFlexGridDataObject ddData(*Data);

    // see if the object has any files in it
	//
	BOOL bHasFiles = ddData.GetFileCount();

    // if it does, it can be dropped here
	//
    *Effect = bHasFiles? DROPEFFECT_COPY: DROPEFFECT_NONE;
}


//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CBigDemoDlg::OnOLEDragDropDemo(...)
// 
// The user dropped some data on the control. Make sure the data is 
// valid (this demo only accepts files), then use the data.
//
void CBigDemoDlg::OnOLEDragDropDemo(LPDISPATCH FAR* Data, long FAR* Effect, 
									short Button, short Shift, float X, float Y) 
{
	// ignore unless this is the OLE drag drop demo
	//
	if (m_iCurrentDemo != 23) return;
    
	// wrap data object IDispatch
	//
	CvsFlexGridDataObject ddData(*Data);

    // make sure the object has files
	//
	BOOL bHasFiles = ddData.GetFileCount();
    if (!bHasFiles) {
		MessageBox("For this demo, we only accept dropping files...");
		return;
	}

    // if it does, open the first file 
	//
	CString strFile = ddData.GetFiles(0);
	FILE* f = fopen((LPCSTR)strFile, "rt");
	if (!f) return;

	// and paste its contents (ten first lines) into control
	//
	long r = m_fgDemo.GetMouseRow(); 
	long c = m_fgDemo.GetMouseCol();
	for (int i = 0; i < 10; i++, r++) {

		// stop when we run out of data or room
		if (feof(f)) break;
		if (r >= m_fgDemo.GetRows()) break;

		// copy data to control
		static char strBuff[101];
		fgets(strBuff, 100, f);
		m_fgDemo.SetTextMatrix(r, c, strBuff);
	}

	// close file and be done
	//
	fclose(f);
}

